欢迎光临
我们一直在努力

Linux屏蔽浏览器上http请求警报的方法

  在Linux系统中浏览器的页面上是不允许出现http请求的,如果出现了http请求就会发生错误,并且Linux系统会向用户发出警报。本文就来介绍一下Linux系统屏蔽浏览器页面上的http请求警报的方法。

  警报代码

  Mixed Content: The page at ‘https://www.taobao.com/‘ was loaded over HTTPS, but requested an insecure image ‘http://g.alicdn.com/s.gif’。 This content should also be served over HTTPS.HTTPS

  改造之后,我们可以在很多页面中看到如下警报:

Linux屏蔽浏览器上http请求警报的方法

  很多运营对 https 没有技术概念,在填入的数据中不免出现 http 的资源,体系庞大,出现疏忽和漏洞也是不可避免的。

  解决方法

  CSP设置upgrade-insecure-requests

  好在 W3C 工作组考虑到了我们升级 HTTPS 的艰难,在 2015 年 4 月份就出了一个 Upgrade Insecure Requests 的草案,他的作用就是让浏览器自动升级请求。

  在我们服务器的响应头中加入:

  header(“Content-Security-Policy: upgrade-insecure-requests”);

  我们的页面是 https 的,而这个页面中包含了大量的 http 资源(图片、iframe等),页面一旦发现存在上述响应头,会在加载 http 资源时自动替换成 https 请求。可以查看 google 提供的一个 demo:

Linux屏蔽浏览器上http请求警报的方法

  不过让人不解的是,这个资源发出了两次请求,猜测是浏览器实现的 bug:

Linux屏蔽浏览器上http请求警报的方法

  当然,如果我们不方便在服务器/Nginx 上操作,也可以在页面中加入 meta 头:

  《meta http-equiv=“Content-Security-Policy” content=“upgrade-insecure-requests” /》

  目前支持这个设置的还只有 chrome 43.0,不过我相信,CSP 将成为未来 web 前端安全大力关注和使用的内容。而 upgrade-insecure-requests 草案也会很快进入 RFC 模式。

  从 W3C 工作组给出的 example,可以看出,这个设置不会对外域的 a 链接做处理,所以可以放心使用。

  以上就是Linux系统屏蔽浏览器页面上的http请求警报的方法的介绍了,因为实际应用中很容易在页面中出现http请求,所以如果不屏蔽警报就会一直显示在那里,比较影响用户体验。

赞(0)
版权声明:本文采用知识共享 署名4.0国际许可协议 [BY-NC-SA] 进行授权
文章名称:《Linux屏蔽浏览器上http请求警报的方法》
文章链接:https://pc.adminn.cn/1857.html
本站属非盈利性网站,不接受任何形式广告。本站提供文章纯教程分享,给网民提供教程,文章均采集网路,如侵犯您的权益,请联系我们删除,QQ:805750011。